<template>
  <div class="container">
    <header class="jumbotron">
      <button class="btn btn-success mr-1" v-on:click="addBeehive()">Dodaj ul</button>
      <button v-if="!content" class="btn btn-info" v-on:click="addBeegarden()">Dodaj pasiekę</button>
    </header>

    <div v-if="content" class="beehive_main_details">
      <Beehives v-bind:specific_beehive="this.emiter"/>
    </div>

    <div class="col-md-8" v-if="content">
      <strong>Twoje ule w pasiece:</strong>
      <hr>

      <div v-for="item in content" v-bind:key="item.id">
        <div>
          <button class="btn btn-info" v-on:click="showDetails(item)">
            {{ item.beehiveName }}
          </button>
          <hr>
        </div>
      </div>
    </div>


  </div>
</template>

<script>
import UserService from '../../services/user.service';
import BeegardenService from '../../services/beegarden.service'
import Beehives from '@/views/Beehive/Beehives'


export default {
  name: 'BoardBeehives',
  data() {
    return {
      content: '',
      emiter: {},
      beegardenIds: ''
    };
  },
  components: {
    Beehives
  },
  computed: {
    currentUser() {
      return this.$store.state.auth.user;
    }
  },
  mounted() {

    if (!this.currentUser) {
      this.$router.push('/login');
    } else if (this.$route.query.beegardenid) {

      // eslint-disable-next-line no-console
      console.log("Get beehives from one specific beegarden with id: " + this.$route.query.beegardenid)

      UserService.getBeehiveBoard(this.$route.query.beegardenid).then(
          response => {
            this.content = response.data;
          },
          error => {
            this.content =
                (error.response && error.response.data && error.response.data.message) ||
                error.message ||
                error.toString();
          }
      );
    } else {
      BeegardenService.getAllBeegardensFromUser(this.currentUser.id).then(
          response => {

            for (const beegarden of response.data)
              this.beegardenIds = this.beegardenIds + beegarden.id + ","

            if (this.beegardenIds) {
              BeegardenService.getAllBeehivesFromSpecificBeegarden(this.beegardenIds).then(
                  response => {
                    this.content = response.data;
                  },
                  error => {
                    this.content =
                        (error.response && error.response.data && error.response.data.message) ||
                        error.message ||
                        error.toString();
                  }
              );
            }
          },
          error => {
            this.content =
                (error.response && error.response.data && error.response.data.message) ||
                error.message ||
                error.toString();
          }
      );
    }
  },
  methods: {
    showDetails(item) {
      this.emiter = item
      this.$emit('specific_beehive', this.emiter);
    },

    addBeegarden() {
      this.$router.push('/addbeegarden');
    },

    addBeehive() {
      this.$router.push('/addbeehive');
    },

  }
};
</script>

<style scoped>

.beehive_main_details {
  float: right; /* add this */
  border-style: groove;
}
</style>